#include <stdio.h>
#include <windows.h>
#include <ddk/ntapi.h>

HANDLE hPipe = INVALID_HANDLE_VALUE;
main(void)
{
    static const WCHAR symlink_name[] = {'\\','d','o','s','d','e','v','i','c','e','s',0};
    static const WCHAR target_name[] = {'\\','p','a','t','h','/','t','o','/','n','o',' ','w','h','e','r','e',0};
    static const WCHAR file_name[] = {'\\','D','o','s','D','e','v','i','c','e','s','\\','C',':',0};
    OBJECT_ATTRIBUTES attr, f_attr;
    IO_STATUS_BLOCK Iosb;
    UNICODE_STRING symlink, target, file;
    HANDLE hFile, hSymlink;
    NTSTATUS status;

    RtlInitUnicodeString(&symlink, symlink_name);
    RtlInitUnicodeString(&target, target_name);
    RtlInitUnicodeString(&file, file_name);
    InitializeObjectAttributes(&attr, &symlink, 0, NULL, NULL);
    InitializeObjectAttributes(&f_attr, &file, OBJ_CASE_INSENSITIVE, NULL, NULL);

    status = NtOpenFile(&hFile, FILE_GENERIC_READ, &f_attr, &Iosb,
                        FILE_SHARE_READ | FILE_SHARE_WRITE,
                        FILE_SYNCHRONOUS_IO_NONALERT);
    fprintf(stderr, "NtOpenFile: status(%08lx)\n", status);
    NtClose(hFile);

    status = ZwCreateSymbolicLinkObject(&hSymlink, SYMBOLIC_LINK_ALL_ACCESS, &attr, &target);
    fprintf(stderr, "NtCreateSymbolicLinkObject: status(%08lx)\n", status);

    status = NtOpenFile(&hFile, FILE_GENERIC_READ, &f_attr, &Iosb,
                        FILE_SHARE_READ | FILE_SHARE_WRITE,
                        FILE_SYNCHRONOUS_IO_NONALERT);
    fprintf(stderr, "NtOpenFile: status(%08lx)\n", status);
    NtClose(hFile);
    NtClose(hSymlink);
}
